Subject: Re: 27.0.50; integer in pcase sometimes compared by eq

From: Mattias Engdegård <[email-masked]>
Date: Thu, 28 Mar 2019 20:51:40 +0100

tor 2019-03-28 klockan 11:25 -0700 skrev Paul Eggert:
> 
> Thanks, it looks good to me; please install into the master branch
> 
> What happens if a source file that uses pcase is compiled on a 64-bit
> machine that has wide fixnums, and is then loaded and run on a 32-bit
> machine that has narrow fixnums? Will this pcase code still work? And
> if
> not, are there similar bugs elsewhere in the pcase code?

Not that I can see; the singular case uses eql for integerp.
I didn't think of the case you described, thanks. We then need a new
function:

  portable-fixnum-p
  guaranteed-fixnum-p
  always-fixnum-p
  fixnum-everywhere-p
  here-a-fixnum-there-a-fixnum-everywhere-a-fixnum-p

and names for the bounds:

  portable-most-{positive,negative}-fixnum
  ...

Name suggestions welcome. Meanwhile, I'll make a new patch.